Inlet.idl
/* SPDX-License-Identifier: BSD-3-Clause */
/*
* Copyright 2009 Raritan Inc. All rights reserved.
*/
#ifndef __PDUMODEL_INLET_IDL__
#define __PDUMODEL_INLET_IDL__
#include <EDevice.idl>
#include <Nameplate.idl>
#include <NumericSensor.idl>
#include <StateSensor.idl>
#include <Pole.idl>
#include <ResidualCurrentStateSensor.idl>
/**
* PDU Model
*/
module pdumodel {
/** %Inlet interface */
interface Inlet_2_0_4 extends EDevice {
/** %Inlet metadata */
structure MetaData {
string label; ///< %Inlet label
string plugType; ///< Plug type
Nameplate_2_0_0 namePlate; ///< %Nameplate information
Rating_2_0_0 rating; ///< Numerical usage ratings
};
/** %Inlet sensors */
structure Sensors {
sensors.NumericSensor_4_0_3 voltage; ///< RMS voltage sensor
sensors.NumericSensor_4_0_3 current; ///< RMS current sensor
sensors.NumericSensor_4_0_3 peakCurrent; ///< Peak current sensor
sensors.NumericSensor_4_0_3 residualCurrent; ///< Residual current sensor
sensors.NumericSensor_4_0_3 residualDCCurrent; ///< DC Residual current sensor
sensors.NumericSensor_4_0_3 activePower; ///< Active power sensor
sensors.NumericSensor_4_0_3 reactivePower; ///< Reactive power sensor
sensors.NumericSensor_4_0_3 apparentPower; ///< Apparent power sensor
sensors.NumericSensor_4_0_3 powerFactor; ///< Power factor sensor
sensors.NumericSensor_4_0_3 displacementPowerFactor; ///< Displacement power factor sensor
sensors.NumericSensor_4_0_3 activeEnergy; ///< Active energy sensor
sensors.NumericSensor_4_0_3 apparentEnergy; ///< Apparent energy sensor
sensors.NumericSensor_4_0_3 unbalancedCurrent; ///< Current unbalance sensor
sensors.NumericSensor_4_0_3 lineFrequency; ///< Line AC frequency sensor
sensors.NumericSensor_4_0_3 phaseAngle; ///< Phase angle sensor
sensors.NumericSensor_4_0_3 crestFactor; ///< Crest factor sensor
sensors.StateSensor_4_0_3 powerQuality; ///< Power quality sensor
sensors.StateSensor_4_0_3 surgeProtectorStatus; ///< Surge protector status sensor
ResidualCurrentStateSensor_2_0_3 residualCurrentStatus; ///< Residual current monitor state sensor
};
/** %Inlet settings */
structure Settings {
string name; ///< User-defined name
};
/** Event: Inlet settings have been changed */
valueobject SettingsChangedEvent extends event.UserEvent {
Settings oldSettings; ///< Settings before change
Settings newSettings; ///< Settings after change
};
/** Event: Inlet has been enabled or disabled */
valueobject EnableStateChangedEvent extends event.UserEvent {
boolean enabled; ///< New enable state
};
/**
* Retrieve the inlet metadata.
*
* @return %Inlet metadata
*/
MetaData getMetaData();
/**
* Get the inlet sensors.
*
* @return %Inlet sensors
*/
Sensors getSensors();
/**
* Get the list of inlet poles.
*
* @return List of inlet poles
*/
vector<Pole_5_0_0> getPoles();
/**
* Retrieve the inlet settings.
*
* @return %Inlet settings
*/
Settings getSettings();
/**
* Change the inlet settings.
*
* @param settings New inlet settings
*
* @return 0 if OK
* @return 1 if any parameters are invalid
*/
int setSettings(in Settings settings);
/**
* Enable/disable PDU operation for this inlet.
*
* When PDU operation is disabled the sensors for this inlet and all
* children will no longer be updated, and outlet switching is no
* longer allowed. This can be useful for multi-inlet units if one
* inlet is temporarily expected to be powered down.
*
* @param enabled \c true to enable PDU operation
*/
void setEnabled(in boolean enabled);
/**
* Test whether PDU operation is enabled for this inlet.
*
* @return \c true if PDU operation is enabled
*/
boolean isEnabled();
};
}
#endif
pdumodel::Inlet_2_0_4::Sensors::crestFactor
sensors::NumericSensor_4_0_3 crestFactor
Crest factor sensor.
Definition: Inlet.idl:49
pdumodel::Inlet_2_0_4::newSettings
Settings newSettings
Settings after change.
Definition: Inlet.idl:63
pdumodel::Inlet_2_0_4::Sensors::residualCurrent
sensors::NumericSensor_4_0_3 residualCurrent
Residual current sensor.
Definition: Inlet.idl:37
pdumodel::Inlet_2_0_4
Inlet interface
Definition: Inlet.idl:22
pdumodel::Inlet_2_0_4::Sensors::activePower
sensors::NumericSensor_4_0_3 activePower
Active power sensor.
Definition: Inlet.idl:39
pdumodel::Inlet_2_0_4::Sensors::unbalancedCurrent
sensors::NumericSensor_4_0_3 unbalancedCurrent
Current unbalance sensor.
Definition: Inlet.idl:46
pdumodel::EDevice
Common base interface for any kind of electrical device that is used in the PDU model, such as inlets, OCPs and outlets.
Definition: EDevice.idl:24
pdumodel::Inlet_2_0_4::Sensors::apparentPower
sensors::NumericSensor_4_0_3 apparentPower
Apparent power sensor.
Definition: Inlet.idl:41
pdumodel::Inlet_2_0_4::Settings
Inlet settings
Definition: Inlet.idl:56
pdumodel::Inlet_2_0_4::Sensors::lineFrequency
sensors::NumericSensor_4_0_3 lineFrequency
Line AC frequency sensor.
Definition: Inlet.idl:47
pdumodel::Inlet_2_0_4::MetaData::plugType
string plugType
Plug type.
Definition: Inlet.idl:27
pdumodel::Inlet_2_0_4::Sensors::current
sensors::NumericSensor_4_0_3 current
RMS current sensor.
Definition: Inlet.idl:35
pdumodel::Inlet_2_0_4::MetaData
Inlet metadata
Definition: Inlet.idl:25
pdumodel::Inlet_2_0_4::MetaData::label
string label
Inlet label
Definition: Inlet.idl:26
pdumodel::Inlet_2_0_4::Sensors::phaseAngle
sensors::NumericSensor_4_0_3 phaseAngle
Phase angle sensor.
Definition: Inlet.idl:48
pdumodel::Inlet_2_0_4::Sensors::displacementPowerFactor
sensors::NumericSensor_4_0_3 displacementPowerFactor
Displacement power factor sensor.
Definition: Inlet.idl:43
pdumodel::ResidualCurrentStateSensor_2_0_3
Residual current state sensor interface.
Definition: ResidualCurrentStateSensor.idl:17
pdumodel::Nameplate_2_0_0
Component nameplate information.
Definition: Nameplate.idl:23
pdumodel::Inlet_2_0_4::Sensors::peakCurrent
sensors::NumericSensor_4_0_3 peakCurrent
Peak current sensor.
Definition: Inlet.idl:36
pdumodel::Inlet_2_0_4::Sensors::residualDCCurrent
sensors::NumericSensor_4_0_3 residualDCCurrent
DC Residual current sensor.
Definition: Inlet.idl:38
pdumodel::Inlet_2_0_4::Settings::name
string name
User-defined name.
Definition: Inlet.idl:57
sensors
Sensors Model.
Definition: AccumulatingNumericSensor.idl:13
pdumodel
PDU Model.
Definition: Ade.idl:12
pdumodel::Inlet_2_0_4::MetaData::rating
Rating_2_0_0 rating
Numerical usage ratings.
Definition: Inlet.idl:29
pdumodel::Inlet_2_0_4::Sensors::apparentEnergy
sensors::NumericSensor_4_0_3 apparentEnergy
Apparent energy sensor.
Definition: Inlet.idl:45
pdumodel::Inlet_2_0_4::Sensors::voltage
sensors::NumericSensor_4_0_3 voltage
RMS voltage sensor.
Definition: Inlet.idl:34
pdumodel::Inlet_2_0_4::MetaData::namePlate
Nameplate_2_0_0 namePlate
Nameplate information
Definition: Inlet.idl:28
pdumodel::Inlet_2_0_4::Sensors::powerQuality
sensors::StateSensor_4_0_3 powerQuality
Power quality sensor.
Definition: Inlet.idl:50
sensors::NumericSensor_4_0_3
A sensor with numeric readings.
Definition: NumericSensor.idl:17
pdumodel::Rating_2_0_0
Numerical usage ratings.
Definition: Nameplate.idl:15
pdumodel::Inlet_2_0_4::Sensors::activeEnergy
sensors::NumericSensor_4_0_3 activeEnergy
Active energy sensor.
Definition: Inlet.idl:44
pdumodel::Inlet_2_0_4::Sensors::surgeProtectorStatus
sensors::StateSensor_4_0_3 surgeProtectorStatus
Surge protector status sensor.
Definition: Inlet.idl:51
pdumodel::Inlet_2_0_4::Sensors
Inlet sensors
Definition: Inlet.idl:33
sensors::StateSensor_4_0_3
Sensor with discrete readings.
Definition: StateSensor.idl:43
pdumodel::Inlet_2_0_4::Sensors::residualCurrentStatus
ResidualCurrentStateSensor_2_0_3 residualCurrentStatus
Residual current monitor state sensor.
Definition: Inlet.idl:52
pdumodel::Inlet_2_0_4::Sensors::powerFactor
sensors::NumericSensor_4_0_3 powerFactor
Power factor sensor.
Definition: Inlet.idl:42
pdumodel::Inlet_2_0_4::Sensors::reactivePower
sensors::NumericSensor_4_0_3 reactivePower
Reactive power sensor.
Definition: Inlet.idl:40